class iptables {

    case ${operatingsystem} {
        centos: { include iptables::redhat }
        redhat: { include iptables::redhat }
        fedora: { include iptables::redhat }
        debian: { include iptables::debian }
        ubuntu: { include iptables::debian }
        default: { warning("EPIC FAIL: Unknown Distribution") }
    }
}

class iptables::redhat {

    service { iptables:
        ensure => running,
        enable => true,
        hasrestart => true,
        hasstatus => true,
        subscribe => File["/etc/sysconfig/iptables"],
    }

    file { "/etc/sysconfig/iptables":
        owner   => root,
        group   => root,
        mode    => 0600,
        source  => "puppet:///iptables/iptables.${hostname}",
    }
}

class iptables::debian {

    service { iptables:
        ensure => running,
        enable => true,
        hasrestart => false,
        restart => "/sbin/iptables-restore < /etc/default/iptables",
        hasstatus => false,
        subscribe => File["/etc/default/iptables"],
    }

    file { "/etc/default/iptables":
        owner   => root,
        group   => root,
        mode    => 0600,
        source  => "puppet:///iptables/iptables.${hostname}
    }
}
